DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Row Editing

The JavaScript DataGrid allows users to edit data in multiple modes. This demo shows the "row" edit mode. To start editing any row, click "Edit" in it. Only one row can be in the edit state at a time.

To enable row edit mode, set the mode property to "row" and assign true to the editing object's allowUpdating, allowAdding, and allowDeleting properties.

Backend API
$(() => { function logEvent(eventName) { const logList = $('#events ul'); const newItem = $('<li>', { text: eventName }); logList.prepend(newItem); } $('#gridContainer').dxDataGrid({ dataSource: employees, keyExpr: 'ID', showBorders: true, paging: { enabled: false, }, editing: { mode: 'row', allowUpdating: true, allowDeleting: true, allowAdding: true, }, columns: [ { dataField: 'Prefix', caption: 'Title', }, 'FirstName', 'LastName', { dataField: 'Position', width: 130, }, { dataField: 'StateID', caption: 'State', width: 125, lookup: { dataSource: states, displayExpr: 'Name', valueExpr: 'ID', }, }, { dataField: 'BirthDate', dataType: 'date', width: 125, }, ], onEditingStart() { logEvent('EditingStart'); }, onInitNewRow() { logEvent('InitNewRow'); }, onRowInserting() { logEvent('RowInserting'); }, onRowInserted() { logEvent('RowInserted'); }, onRowUpdating() { logEvent('RowUpdating'); }, onRowUpdated() { logEvent('RowUpdated'); }, onRowRemoving() { logEvent('RowRemoving'); }, onRowRemoved() { logEvent('RowRemoved'); }, onSaving() { logEvent('Saving'); }, onSaved() { logEvent('Saved'); }, onEditCanceling() { logEvent('EditCanceling'); }, onEditCanceled() { logEvent('EditCanceled'); }, }); $('#clear').dxButton({ text: 'Clear', onClick() { $('#events ul').empty(); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> <div id="events"> <div> <div class="caption"> Fired events </div> <div id="clear"></div> </div> <ul></ul> </div> </div> </body> </html>
#events { background-color: rgba(191, 191, 191, 0.15); padding: 20px; margin-top: 20px; } #events > div { padding-bottom: 5px; } #events > div::after { content: ""; display: table; clear: both; } #events #clear { float: right; } #events .caption { float: left; font-weight: bold; font-size: 115%; line-height: 115%; padding-top: 7px; } #events ul { list-style: none; max-height: 100px; overflow: auto; margin: 0; } #events ul li { padding: 7px 0; border-bottom: 1px solid #ddd; } #events ul li:last-child { border-bottom: none; }
const employees = [{ ID: 1, FirstName: 'John', LastName: 'Heart', Prefix: 'Mr.', Position: 'CEO', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St.', StateID: 5, }, { ID: 2, FirstName: 'Olivia', LastName: 'Peyton', Prefix: 'Mrs.', Position: 'Sales Assistant', BirthDate: '1981/06/03', HireDate: '2012/05/14', Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.', Address: '807 W Paseo Del Mar', StateID: 5, }, { ID: 3, FirstName: 'Robert', LastName: 'Reagan', Prefix: 'Mr.', Position: 'CMO', BirthDate: '1974/09/07', HireDate: '2002/11/08', Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.', Address: '4 Westmoreland Pl.', StateID: 4, }, { ID: 4, FirstName: 'Greta', LastName: 'Sims', Prefix: 'Ms.', Position: 'HR Manager', BirthDate: '1977/11/22', HireDate: '1998/04/23', Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.", Address: '1700 S Grandview Dr.', StateID: 11, }, { ID: 5, FirstName: 'Brett', LastName: 'Wade', Prefix: 'Mr.', Position: 'IT Manager', BirthDate: '1968/12/01', HireDate: '2009/03/06', Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).', Address: '1120 Old Mill Rd.', StateID: 13, }, { ID: 6, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.", Address: '4600 N Virginia Rd.', StateID: 44, }, { ID: 7, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', StateID: 5, }, { ID: 8, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', StateID: 4, }, { ID: 9, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', StateID: 26, }, { ID: 10, FirstName: 'Taylor', LastName: 'Riley', Prefix: 'Mr.', Position: 'Network Admin', BirthDate: '1982/08/14', HireDate: '2012/04/14', Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.", Address: '7776 Torreyson Dr', StateID: 5, }, { ID: 11, FirstName: 'Sam', LastName: 'Hill', Prefix: 'Mr.', Position: 'Sales Assistant', BirthDate: '1984/02/17', HireDate: '2012/02/01', Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.', Address: '645 Prospect Crescent', StateID: 11, }, { ID: 12, FirstName: 'Kelly', LastName: 'Rodriguez', Prefix: 'Ms.', Position: 'Support Assistant', BirthDate: '1988/05/11', HireDate: '2012/10/13', Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.", Address: '1601 W Mountain St.', StateID: 5, }, { ID: 13, FirstName: 'Natalie', LastName: 'Maguirre', Prefix: 'Mrs.', Position: 'Trainer', BirthDate: '1977/10/07', HireDate: '2008/06/19', Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.', Address: '6400 E Bixby Hill Rd', StateID: 29, }, { ID: 14, FirstName: 'Walter', LastName: 'Hobbs', Prefix: 'Mr.', Position: 'Programmer', BirthDate: '1984/12/24', HireDate: '2011/02/17', Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.", Address: '10385 Shadow Oak Dr', StateID: 13, }]; const states = [{ ID: 1, Name: 'Alabama', }, { ID: 2, Name: 'Alaska', }, { ID: 3, Name: 'Arizona', }, { ID: 4, Name: 'Arkansas', }, { ID: 5, Name: 'California', }, { ID: 6, Name: 'Colorado', }, { ID: 7, Name: 'Connecticut', }, { ID: 8, Name: 'Delaware', }, { ID: 9, Name: 'District of Columbia', }, { ID: 10, Name: 'Florida', }, { ID: 11, Name: 'Georgia', }, { ID: 12, Name: 'Hawaii', }, { ID: 13, Name: 'Idaho', }, { ID: 14, Name: 'Illinois', }, { ID: 15, Name: 'Indiana', }, { ID: 16, Name: 'Iowa', }, { ID: 17, Name: 'Kansas', }, { ID: 18, Name: 'Kentucky', }, { ID: 19, Name: 'Louisiana', }, { ID: 20, Name: 'Maine', }, { ID: 21, Name: 'Maryland', }, { ID: 22, Name: 'Massachusetts', }, { ID: 23, Name: 'Michigan', }, { ID: 24, Name: 'Minnesota', }, { ID: 25, Name: 'Mississippi', }, { ID: 26, Name: 'Missouri', }, { ID: 27, Name: 'Montana', }, { ID: 28, Name: 'Nebraska', }, { ID: 29, Name: 'Nevada', }, { ID: 30, Name: 'New Hampshire', }, { ID: 31, Name: 'New Jersey', }, { ID: 32, Name: 'New Mexico', }, { ID: 33, Name: 'New York', }, { ID: 34, Name: 'North Carolina', }, { ID: 35, Name: 'Ohio', }, { ID: 36, Name: 'Oklahoma', }, { ID: 37, Name: 'Oregon', }, { ID: 38, Name: 'Pennsylvania', }, { ID: 39, Name: 'Rhode Island', }, { ID: 40, Name: 'South Carolina', }, { ID: 41, Name: 'South Dakota', }, { ID: 42, Name: 'Tennessee', }, { ID: 43, Name: 'Texas', }, { ID: 44, Name: 'Utah', }, { ID: 45, Name: 'Vermont', }, { ID: 46, Name: 'Virginia', }, { ID: 47, Name: 'Washington', }, { ID: 48, Name: 'West Virginia', }, { ID: 49, Name: 'Wisconsin', }, { ID: 50, Name: 'Wyoming', }, { ID: 51, Name: 'North Dakota', }];

Edit operations raise events that you can handle with the following functions:

This demo shows an event log under the grid.

Backend API
<dx-data-grid
id="gridContainer"
[dataSource]="dataSource"
keyExpr="ID"
[allowColumnReordering]="true"
[showBorders]="true"
(onEditingStart)="logEvent('EditingStart')"
(onInitNewRow)="logEvent('InitNewRow')"
(onRowInserting)="logEvent('RowInserting')"
(onRowInserted)="logEvent('RowInserted')"
(onRowUpdating)="logEvent('RowUpdating')"
(onRowUpdated)="logEvent('RowUpdated')"
(onRowRemoving)="logEvent('RowRemoving')"
(onRowRemoved)="logEvent('RowRemoved')"
(onSaving)="logEvent('Saving')"
(onSaved)="logEvent('Saved')"
(onEditCanceling)="logEvent('EditCanceling')"
(onEditCanceled)="logEvent('EditCanceled')"
>
<dxo-paging [enabled]="true"></dxo-paging>
<dxo-editing
mode="row"
[allowUpdating]="true"
[allowDeleting]="true"
[allowAdding]="true"
>
</dxo-editing>
<dxi-column dataField="Prefix" caption="Title"></dxi-column>
<dxi-column dataField="FirstName"></dxi-column>
<dxi-column dataField="LastName"></dxi-column>
<dxi-column dataField="Position" [width]="130"></dxi-column>
<dxi-column dataField="StateID" caption="State" [width]="125">
<dxo-lookup [dataSource]="states" displayExpr="Name" valueExpr="ID">
</dxo-lookup>
</dxi-column>
<dxi-column dataField="BirthDate" [width]="125" dataType="date"> </dxi-column>
</dx-data-grid>
<div id="events">
<div>
<div class="caption"> Fired events </div>
<dx-button id="clear" text="Clear" (onClick)="clearEvents()"></dx-button>
</div>
<ul>
<li *ngFor="let event of events">{{ event }}</li>
</ul>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule, DxButtonModule } from 'devextreme-angular';
import { Service, Employee, State } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
})
export class AppComponent {
dataSource: Employee[];
states: State[];
events: Array<string> = [];
constructor(service: Service) {
this.dataSource = service.getEmployees();
this.states = service.getStates();
}
logEvent(eventName) {
this.events.unshift(eventName);
}
clearEvents() {
this.events = [];
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxButtonModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #events {
background-color: rgba(191, 191, 191, 0.15);
padding: 20px;
margin-top: 20px;
}
::ng-deep #events > div {
padding-bottom: 5px;
}
::ng-deep #events > div::after {
content: "";
display: table;
clear: both;
}
::ng-deep #events #clear {
float: right;
}
::ng-deep #events .caption {
float: left;
font-weight: bold;
font-size: 115%;
line-height: 115%;
padding-top: 7px;
}
::ng-deep #events ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
::ng-deep #events ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
::ng-deep #events ul li:last-child {
border-bottom: none;
}
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
StateID: number;
}
export class State {
ID: number;
Name: string;
}
const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
const states: State[] = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
getStates() {
return states;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Edit operations raise events that you can handle with the following functions:
- onEditingStart
- onInitNewRow
- onRowInserting / onRowInserted
- onRowUpdating / onRowUpdated
- onRowRemoving / onRowRemoved
- onSaving / onSaved
- onEditCanceling / onEditCanceled
This demo shows an event log under the grid.

Backend API
import React, { useCallback, useState } from 'react';
import Button from 'devextreme-react/button';
import DataGrid, { Column, Editing, Paging, Lookup } from 'devextreme-react/data-grid';
import { employees, states } from './data.ts';
const App = () => {
const [events, setEvents] = useState<string[]>([]);
const logEvent = useCallback((eventName: string) => {
setEvents((previousEvents) => [eventName, ...previousEvents]);
}, []);
const clearEvents = useCallback(() => {
setEvents([]);
}, []);
return (
<>
<DataGrid
id="gridContainer"
dataSource={employees}
keyExpr="ID"
allowColumnReordering={true}
showBorders={true}
onEditingStart={() => logEvent('EditingStart')}
onInitNewRow={() => logEvent('InitNewRow')}
onRowInserting={() => logEvent('RowInserting')}
onRowInserted={() => logEvent('RowInserted')}
onRowUpdating={() => logEvent('RowUpdating')}
onRowUpdated={() => logEvent('RowUpdated')}
onRowRemoving={() => logEvent('RowRemoving')}
onRowRemoved={() => logEvent('RowRemoved')}
onSaving={() => logEvent('Saving')}
onSaved={() => logEvent('Saved')}
onEditCanceling={() => logEvent('EditCanceling')}
onEditCanceled={() => logEvent('EditCanceled')}>
<Paging enabled={true} />
<Editing
mode="row"
allowUpdating={true}
allowDeleting={true}
allowAdding={true} />
<Column dataField="Prefix" caption="Title" />
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column dataField="Position" width={130} />
<Column
dataField="StateID"
caption="State"
width={125}
>
<Lookup dataSource={states} displayExpr="Name" valueExpr="ID" />
</Column>
<Column
dataField="BirthDate"
width={125}
dataType="date" />
</DataGrid>
<div id="events">
<div>
<div className="caption">Fired events</div>
<Button id="clear" text="Clear" onClick={clearEvents} />
</div>
<ul>
{events.map((event, index) => <li key={index}>{event}</li>)}
</ul>
</div>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Button from 'devextreme-react/button';
import DataGrid, {
Column, Editing, Paging, Lookup,
} from 'devextreme-react/data-grid';
import { employees, states } from './data.js';
const App = () => {
const [events, setEvents] = useState([]);
const logEvent = useCallback((eventName) => {
setEvents((previousEvents) => [eventName, ...previousEvents]);
}, []);
const clearEvents = useCallback(() => {
setEvents([]);
}, []);
return (
<>
<DataGrid
id="gridContainer"
dataSource={employees}
keyExpr="ID"
allowColumnReordering={true}
showBorders={true}
onEditingStart={() => logEvent('EditingStart')}
onInitNewRow={() => logEvent('InitNewRow')}
onRowInserting={() => logEvent('RowInserting')}
onRowInserted={() => logEvent('RowInserted')}
onRowUpdating={() => logEvent('RowUpdating')}
onRowUpdated={() => logEvent('RowUpdated')}
onRowRemoving={() => logEvent('RowRemoving')}
onRowRemoved={() => logEvent('RowRemoved')}
onSaving={() => logEvent('Saving')}
onSaved={() => logEvent('Saved')}
onEditCanceling={() => logEvent('EditCanceling')}
onEditCanceled={() => logEvent('EditCanceled')}
>
<Paging enabled={true} />
<Editing
mode="row"
allowUpdating={true}
allowDeleting={true}
allowAdding={true}
/>
<Column
dataField="Prefix"
caption="Title"
/>
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column
dataField="Position"
width={130}
/>
<Column
dataField="StateID"
caption="State"
width={125}
>
<Lookup
dataSource={states}
displayExpr="Name"
valueExpr="ID"
/>
</Column>
<Column
dataField="BirthDate"
width={125}
dataType="date"
/>
</DataGrid>
<div id="events">
<div>
<div className="caption">Fired events</div>
<Button
id="clear"
text="Clear"
onClick={clearEvents}
/>
</div>
<ul>
{events.map((event, index) => (
<li key={index}>{event}</li>
))}
</ul>
</div>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
export const states = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employees = [
{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes:
'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
},
{
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes:
'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
},
{
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes:
'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
},
{
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes:
"Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
},
{
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes:
'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
},
{
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes:
"Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
},
{
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes:
'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
},
{
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes:
'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
},
{
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes:
'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
},
{
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes:
"If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
},
{
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes:
'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
},
{
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes:
"Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
},
{
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes:
'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
},
{
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes:
"Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
},
];
export const states = [
{
ID: 1,
Name: 'Alabama',
},
{
ID: 2,
Name: 'Alaska',
},
{
ID: 3,
Name: 'Arizona',
},
{
ID: 4,
Name: 'Arkansas',
},
{
ID: 5,
Name: 'California',
},
{
ID: 6,
Name: 'Colorado',
},
{
ID: 7,
Name: 'Connecticut',
},
{
ID: 8,
Name: 'Delaware',
},
{
ID: 9,
Name: 'District of Columbia',
},
{
ID: 10,
Name: 'Florida',
},
{
ID: 11,
Name: 'Georgia',
},
{
ID: 12,
Name: 'Hawaii',
},
{
ID: 13,
Name: 'Idaho',
},
{
ID: 14,
Name: 'Illinois',
},
{
ID: 15,
Name: 'Indiana',
},
{
ID: 16,
Name: 'Iowa',
},
{
ID: 17,
Name: 'Kansas',
},
{
ID: 18,
Name: 'Kentucky',
},
{
ID: 19,
Name: 'Louisiana',
},
{
ID: 20,
Name: 'Maine',
},
{
ID: 21,
Name: 'Maryland',
},
{
ID: 22,
Name: 'Massachusetts',
},
{
ID: 23,
Name: 'Michigan',
},
{
ID: 24,
Name: 'Minnesota',
},
{
ID: 25,
Name: 'Mississippi',
},
{
ID: 26,
Name: 'Missouri',
},
{
ID: 27,
Name: 'Montana',
},
{
ID: 28,
Name: 'Nebraska',
},
{
ID: 29,
Name: 'Nevada',
},
{
ID: 30,
Name: 'New Hampshire',
},
{
ID: 31,
Name: 'New Jersey',
},
{
ID: 32,
Name: 'New Mexico',
},
{
ID: 33,
Name: 'New York',
},
{
ID: 34,
Name: 'North Carolina',
},
{
ID: 35,
Name: 'Ohio',
},
{
ID: 36,
Name: 'Oklahoma',
},
{
ID: 37,
Name: 'Oregon',
},
{
ID: 38,
Name: 'Pennsylvania',
},
{
ID: 39,
Name: 'Rhode Island',
},
{
ID: 40,
Name: 'South Carolina',
},
{
ID: 41,
Name: 'South Dakota',
},
{
ID: 42,
Name: 'Tennessee',
},
{
ID: 43,
Name: 'Texas',
},
{
ID: 44,
Name: 'Utah',
},
{
ID: 45,
Name: 'Vermont',
},
{
ID: 46,
Name: 'Virginia',
},
{
ID: 47,
Name: 'Washington',
},
{
ID: 48,
Name: 'West Virginia',
},
{
ID: 49,
Name: 'Wisconsin',
},
{
ID: 50,
Name: 'Wyoming',
},
{
ID: 51,
Name: 'North Dakota',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#events {
background-color: rgba(191, 191, 191, 0.15);
padding: 20px;
margin-top: 20px;
}
#events > div {
padding-bottom: 5px;
}
#events > div::after {
content: "";
display: table;
clear: both;
}
#events #clear {
float: right;
}
#events .caption {
float: left;
font-weight: bold;
font-size: 115%;
line-height: 115%;
padding-top: 7px;
}
#events ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#events ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
#events ul li:last-child {
border-bottom: none;
}
Edit operations raise events that you can handle with the following functions:
- onEditingStart
- onInitNewRow
- onRowInserting / onRowInserted
- onRowUpdating / onRowUpdated
- onRowRemoving / onRowRemoved
- onSaving / onSaved
- onEditCanceling / onEditCanceled
This demo shows an event log under the grid.

Backend API
<template>
<div>
<DxDataGrid
id="gridContainer"
:data-source="employees"
:allow-column-reordering="true"
:show-borders="true"
key-expr="ID"
@editing-start="logEvent('EditingStart')"
@init-new-row="logEvent('InitNewRow')"
@row-inserting="logEvent('RowInserting')"
@row-inserted="logEvent('RowInserted')"
@row-updating="logEvent('RowUpdating')"
@row-updated="logEvent('RowUpdated')"
@row-removing="logEvent('RowRemoving')"
@row-removed="logEvent('RowRemoved')"
@saving="logEvent('Saving')"
@saved="logEvent('Saved')"
@edit-canceling="logEvent('EditCanceling')"
@edit-canceled="logEvent('EditCanceled')"
>
<DxPaging :enabled="true"/>
<DxEditing
:allow-updating="true"
:allow-deleting="true"
:allow-adding="true"
mode="row"
/>
<DxColumn
data-field="Prefix"
caption="Title"
/>
<DxColumn data-field="FirstName"/>
<DxColumn data-field="LastName"/>
<DxColumn
:width="130"
data-field="Position"
/>
<DxColumn
:width="125"
data-field="StateID"
caption="State"
>
<DxLookup
:data-source="states"
display-expr="Name"
value-expr="ID"
/>
</DxColumn>
<DxColumn
:width="125"
data-field="BirthDate"
data-type="date"
/>
</DxDataGrid>
<div id="events">
<div>
<div class="caption">
Fired events
</div>
<DxButton
id="clear"
text="Clear"
@click="clearEvents()"
/>
</div>
<ul>
<li
v-for="(event, index) in events"
:key="index"
>{{ event }}</li>
</ul>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxButton from 'devextreme-vue/button';
import {
DxDataGrid, DxColumn, DxEditing, DxPaging, DxLookup,
} from 'devextreme-vue/data-grid';
import { employees, states } from './data.ts';
const events = ref<string[]>([]);
const logEvent = (eventName: string) => {
events.value.unshift(eventName);
};
const clearEvents = () => {
events.value = [];
};
</script>
<style>
#events {
background-color: rgba(191, 191, 191, 0.15);
padding: 20px;
margin-top: 20px;
}
#events > div {
padding-bottom: 5px;
}
#events > div::after {
content: "";
display: table;
clear: both;
}
#events #clear {
float: right;
}
#events .caption {
float: left;
font-weight: bold;
font-size: 115%;
line-height: 115%;
padding-top: 7px;
}
#events ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#events ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
#events ul li:last-child {
border-bottom: none;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export type Employee = {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
StateID: number;
};
export type State = {
ID: number;
Name: string;
};
export const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St.',
StateID: 5,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981/06/03',
HireDate: '2012/05/14',
Notes: 'Olivia loves to sell. She has been selling DevAV products since 2012. \r\n\r\nOlivia was homecoming queen in high school. She is expecting her first child in 6 months. Good Luck Olivia.',
Address: '807 W Paseo Del Mar',
StateID: 5,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974/09/07',
HireDate: '2002/11/08',
Notes: 'Robert was recently voted the CMO of the year by CMO Magazine. He is a proud member of the DevAV Management Team.\r\n\r\nRobert is a championship BBQ chef, so when you get the chance ask him for his secret recipe.',
Address: '4 Westmoreland Pl.',
StateID: 4,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977/11/22',
HireDate: '1998/04/23',
Notes: "Greta has been DevAV's HR Manager since 2003. She joined DevAV from Sonee Corp.\r\n\r\nGreta is currently training for the NYC marathon. Her best marathon time is 4 hours. Go Greta.",
Address: '1700 S Grandview Dr.',
StateID: 11,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968/12/01',
HireDate: '2009/03/06',
Notes: 'Brett came to DevAv from Microsoft and has led our IT department since 2012.\r\n\r\nWhen he is not working hard for DevAV, he coaches Little League (he was a high school pitcher).',
Address: '1120 Old Mill Rd.',
StateID: 13,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
StateID: 44,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
StateID: 5,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
StateID: 4,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
StateID: 26,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982/08/14',
HireDate: '2012/04/14',
Notes: "If you are like the rest of us at DevAV, then you've probably reached out for help from Taylor. He does a great job as a member of our IT department.",
Address: '7776 Torreyson Dr',
StateID: 5,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
BirthDate: '1984/02/17',
HireDate: '2012/02/01',
Notes: 'Sammy is proud to be a member of the DevAV team. He joined the team in 2012 and has been in the sales department from the beginning.\r\n\r\nHe has just picked up golf so you can find him on the links every weekend.',
Address: '645 Prospect Crescent',
StateID: 11,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Support Assistant',
BirthDate: '1988/05/11',
HireDate: '2012/10/13',
Notes: "Kelly loves people and that's why she joined DevAV's support department. One of the funniest people in the company, she does stand-up on the weekends at the Laugh Factory.",
Address: '1601 W Mountain St.',
StateID: 5,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Trainer',
BirthDate: '1977/10/07',
HireDate: '2008/06/19',
Notes: 'Natalie travels the US and teaches our partners how to explain the benefits of our products to customers.\r\n\r\nShe is a proud wife and mom and volunteers her time at the elementary school.',
Address: '6400 E Bixby Hill Rd',
StateID: 29,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Programmer',
BirthDate: '1984/12/24',
HireDate: '2011/02/17',
Notes: "Walter has been developing apps and websites for DevAV since 2011. His passion is software and if you ever walk by his desk, you'll know why.\r\n\r\nWally once worked 72 hours straight - writing code and fixing bugs.",
Address: '10385 Shadow Oak Dr',
StateID: 13,
}];
export const states: State[] = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}, {
ID: 6,
Name: 'Colorado',
}, {
ID: 7,
Name: 'Connecticut',
}, {
ID: 8,
Name: 'Delaware',
}, {
ID: 9,
Name: 'District of Columbia',
}, {
ID: 10,
Name: 'Florida',
}, {
ID: 11,
Name: 'Georgia',
}, {
ID: 12,
Name: 'Hawaii',
}, {
ID: 13,
Name: 'Idaho',
}, {
ID: 14,
Name: 'Illinois',
}, {
ID: 15,
Name: 'Indiana',
}, {
ID: 16,
Name: 'Iowa',
}, {
ID: 17,
Name: 'Kansas',
}, {
ID: 18,
Name: 'Kentucky',
}, {
ID: 19,
Name: 'Louisiana',
}, {
ID: 20,
Name: 'Maine',
}, {
ID: 21,
Name: 'Maryland',
}, {
ID: 22,
Name: 'Massachusetts',
}, {
ID: 23,
Name: 'Michigan',
}, {
ID: 24,
Name: 'Minnesota',
}, {
ID: 25,
Name: 'Mississippi',
}, {
ID: 26,
Name: 'Missouri',
}, {
ID: 27,
Name: 'Montana',
}, {
ID: 28,
Name: 'Nebraska',
}, {
ID: 29,
Name: 'Nevada',
}, {
ID: 30,
Name: 'New Hampshire',
}, {
ID: 31,
Name: 'New Jersey',
}, {
ID: 32,
Name: 'New Mexico',
}, {
ID: 33,
Name: 'New York',
}, {
ID: 34,
Name: 'North Carolina',
}, {
ID: 35,
Name: 'Ohio',
}, {
ID: 36,
Name: 'Oklahoma',
}, {
ID: 37,
Name: 'Oregon',
}, {
ID: 38,
Name: 'Pennsylvania',
}, {
ID: 39,
Name: 'Rhode Island',
}, {
ID: 40,
Name: 'South Carolina',
}, {
ID: 41,
Name: 'South Dakota',
}, {
ID: 42,
Name: 'Tennessee',
}, {
ID: 43,
Name: 'Texas',
}, {
ID: 44,
Name: 'Utah',
}, {
ID: 45,
Name: 'Vermont',
}, {
ID: 46,
Name: 'Virginia',
}, {
ID: 47,
Name: 'Washington',
}, {
ID: 48,
Name: 'West Virginia',
}, {
ID: 49,
Name: 'Wisconsin',
}, {
ID: 50,
Name: 'Wyoming',
}, {
ID: 51,
Name: 'North Dakota',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
Edit operations raise events that you can handle with the following functions:
- onEditingStart
- onInitNewRow
- onRowInserting / onRowInserted
- onRowUpdating / onRowUpdated
- onRowRemoving / onRowRemoved
- onSaving / onSaved
- onEditCanceling / onEditCanceled
This demo shows an event log under the grid.